//////////////////////////////////////////////////////////////////////////////////////////////
// Clase base para el trabajar con vectores                                                 //
//                                                                                          //
//                                                                                          //
// Anlisis y Diseo y Programacin:                                                        //
//                                                                                          //
// Nombre:   Antonio Carrillo Ledesma                                                       //
// E-mail:   acl@www.mmc.geofisica.unam.mx                                                  //
// Pgina:   http://www.mmc.geofisica.unam.mx/acl                                           //
//                                                                                          //
//                                                                                          //
// Este programa es software libre. Puede redistribuirlo y/o modificarlo                    //
// bajo los trminos de la Licencia Pblica General de GNU segn es                         //
// publicada por la Free Software Foundation, bien de la versin 2 de                       //
// dicha Licencia o bien (segn su eleccin) de cualquier versin                           //
// posterior.                                                                               //
//                                                                                          //
// Este programa se distribuye con la esperanza de que sea til, pero SIN                   //
// NINGUNA GARANTA, incluso sin la garanta MERCANTIL implcita o sin                      //
// garantizar la CONVENIENCIA PARA UN PROPSITO PARTICULAR. Vase la                        //
// Licencia Pblica General de GNU para ms detalles.                                       //
//                                                                                          //
// Debera haber recibido una copia de la Licencia Pblica General junto                    //
// con este programa. Si no ha sido as, escriba a la Free Software                         //
// Foundation, Inc., en 675 Mass Ave, Cambridge, MA 02139, EEUU.                            //
//                                                                                          //
//                                                                                          //
//////////////////////////////////////////////////////////////////////////////////////////////


#ifndef __Vector_Base__
#define __Vector_Base__


#include <stdlib.h>
#include <string.h>
#include <stdio.h>





///  Clase base para el trabajar con vectores
/** @author Antonio Carrillo Ledesma
    @date primavera 2009
    @version 1.0.1
    @bug No hay errores conocidos
*/
class Vector_Base
{
protected:

   /// Nmero de columnas del vector
   int Col;

   /// Nombre del vector
   char *Nmb;



public:


   /// Constructor de la clase
   Vector_Base(void)
   {
      Col = 0;
      Nmb = NULL;
   }

   /// Destructor de la clase
   ~Vector_Base()
   {
      delete []Nmb;
      Nmb = NULL;
   }

   /// Asigna nombre al vector
   /** @param nmb Nombre del vector */
   void asignaNombre(const char *nmb)
   {
      delete []Nmb;
      Nmb = NULL;
      Nmb = new char[strlen(nmb)+2];
#ifdef DEPURAR
      if (!Nmb)
      {
         printf("\nError no hay memoria para el nombre del vector\n");
         exit(1);
      }
#endif
      strcpy(Nmb, nmb);
   }


   /// Retorna el nombre del vector
   /** @return Regresa un puntero al nombre del vector */
   inline char *nombre(void)
   {
      return Nmb;
   }

   /// Retorna el nmero de columnas del vector
   /** @return Regresa el nmero de columnas del vector */
   inline int columnas(void)
   {
      return Col;
   }


   /// Visualiza informacin general del vector
   virtual void visualizaInformacion(void) = 0;

};

#endif
